<?php
/**
 * DokuWiki Default Template
 *
 * This is the template you need to change for the overall look
 * of DokuWiki.
 *
 * You should leave the doctype at the very top - It should
 * always be the very first line of a document.
 *
 * @link   http://wiki.splitbrain.org/wiki:tpl:templates
 * @author Andreas Gohr <andi@splitbrain.org>
 */

// must be run from within DokuWiki
if (!defined('DOKU_INC')) die();

// include functions that provide sidebar functionality
@require_once(dirname(__FILE__).'/tplfn_sidebar.php');

// include translations of the template strings
@require_once(dirname(__FILE__).'/lang/'.tpl_getConf('btl_language').'/settings.php');

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $conf['lang']?>"
 lang="<?php echo $conf['lang']?>" dir="<?php echo $lang['direction']?>">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>
     <?php echo hsc(tpl_img_getTag('IPTC.Headline',$IMG))?>
    [<?php echo strip_tags($conf['title'])?>]
  </title>

  <?php tpl_metaheaders()?>
  <?php /*old includehook*/ @include('meta.php')?>
  <link rel="stylesheet"           media="all"    type="text/css" title="default"  href="/common/css/wiki.css" />

</head>

<body>

<?php @include('../common/php_inc/bandeau.php');?>

  <?php html_msgarea()?>

  <div id="SideBar">

    <div id="WikiActionLink1" class="BlockBase SideBarElement ActionLink">
      <div class="TitleBlockBase"><?php echo $lang['img_backto']?></div>
        <?php print nl2br(hsc(tpl_img_getTag(array('IPTC.Caption',
                                               'EXIF.UserComment',
                                               'EXIF.TIFFImageDescription',
                                               'EXIF.TIFFUserComment')))); ?>
        <?php tpl_pagelink($ID)?></p>
    </div> <!-- Fin de #WikiActionLink1 -->

    <div id="WikiActionLink2" class="BlockBase SideBarElement ActionLink">
      <div class="TitleBlockBase">Détails</div>
      <dl>
        <?php
          $t = tpl_img_getTag('Date.EarliestTime');
          if($t) print '<dt>'.$lang['img_date'].':</dt><dd>'.date($conf['dformat'],$t).'</dd>';

          $t = tpl_img_getTag('File.Name');
          if($t) print '<dt>'.$lang['img_fname'].':</dt><dd>'.hsc($t).'</dd>';

          $t = tpl_img_getTag(array('Iptc.Byline','Exif.TIFFArtist','Exif.Artist','Iptc.Credit'));
          if($t) print '<dt>'.$lang['img_artist'].':</dt><dd>'.hsc($t).'</dd>';

          $t = tpl_img_getTag(array('Iptc.CopyrightNotice','Exif.TIFFCopyright','Exif.Copyright'));
          if($t) print '<dt>'.$lang['img_copyr'].':</dt><dd>'.hsc($t).'</dd>';

          $t = tpl_img_getTag('File.Format');
          if($t) print '<dt>'.$lang['img_format'].':</dt><dd>'.hsc($t).'</dd>';

          $t = tpl_img_getTag('File.NiceSize');
          if($t) print '<dt>'.$lang['img_fsize'].':</dt><dd>'.hsc($t).'</dd>';

          $t = tpl_img_getTag('Simple.Camera');
          if($t) print '<dt>'.$lang['img_camera'].':</dt><dd>'.hsc($t).'</dd>';

          $t = tpl_img_getTag(array('IPTC.Keywords','IPTC.Category'));
          if($t) print '<dt>'.$lang['img_keywords'].':</dt><dd>'.hsc($t).'</dd>';

        ?>
      </dl>
    </div> <!-- Fin de #WikiActionLink2 -->

  </div> <!-- Fin de #sidebar -->

  <div id="Main" class="BlockBase">

    <div id="WikiContent">
      <?php if($ERROR){ print $ERROR; }else{ ?>

      <h1><?php echo hsc(tpl_img_getTag('IPTC.Headline',$IMG))?></h1>

      <div id="DetailImg">
        <?php tpl_img(900,700) ?>
      </div>

      <?php } /* Fin du if($ERROR) */?>
    </div> <!-- Fin de #WikiContent -->

    <?php //Comment in for Debug// dbg(tpl_img_getTag('Simple.Raw'));?>
  </div> <!-- fin de #Main -->

  <?php @include('footer.php')?>
  <div class="no"><?php /* provide DokuWiki housekeeping, required in all templates */ tpl_indexerWebBug()?></div>

</body>
</html>
