<?php
/**
 * DokuWiki AJAX call handler
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Andreas Gohr <andi@splitbrain.org>
 */

//fix for Opera XMLHttpRequests
if(!count($_POST) && $HTTP_RAW_POST_DATA){
  parse_str($HTTP_RAW_POST_DATA, $_POST);
}

if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../../');
require_once(DOKU_INC.'inc/init.php');
require_once(DOKU_INC.'inc/common.php');
require_once(DOKU_INC.'inc/pageutils.php');
require_once(DOKU_INC.'inc/auth.php');
//close sesseion
session_write_close();

header('Content-Type: text/html; charset=utf-8');


//call the requested function
if(isset($_POST['call']))
  $call = 'ajax_'.$_POST['call'];
else if(isset($_GET['call']))
  $call = 'ajax_'.$_GET['call'];
else
  exit;
if(function_exists($call)){
  $call();
}else{
  $call = $_POST['call'];
  $evt = new Doku_Event('AJAX_CALL_UNKNOWN', $call);
  if ($evt->advise_before()) {
    print "AJAX call '".htmlspecialchars($_POST['call'])."' unknown!\n";
  }
  $evt->advise_after();
  unset($evt);
}

/**
 * Return sub index for index view
 *
 * @author Andreas Gohr <andi@splitbrain.org>
 */
function ajax_index(){
  global $conf;
  require_once(DOKU_INC.'inc/search.php');
  require_once(DOKU_INC.'inc/html.php');
  require_once(DOKU_INC.DOKU_TPL.'/yani_html.php');

  // wanted namespace
  $ns  = cleanID($_POST['idx']);
  $dir  = utf8_encodeFN(str_replace(':','/',$ns));

  $lvl = count(explode(':',$ns));

  $data = array();
  search($data,$conf['datadir'],'search_index',array('ns' => $ns),$dir);
  foreach($data as $item){
    /* Don't display 'start page' as they are linked within category */
    if ( ereg('^.*:'.$conf['start'].'$', $item['id']) ) continue;
    $item['level'] = $lvl+1;
    echo html_li_index($item);
    echo '<div class="li">';
    echo yani_html_list_index($item);
    echo '</div>';
    echo '</li>';
  }
}

//Setup VIM: ex: et ts=2 enc=utf-8 :
?>
