<?php
/*
 *
 * This is not currently part of the official Dokuwiki release
 *
 * This work is based on the Sidebar by
 * @author Christopher Smith <chris@jalakai.co.uk>
 *
 * @author Jonesy <jonesy@oryma.org>
 */

/* -------------------- Private functions -------------------- */

function getStartHeading($id) {
  static $xhtml_renderer = NULL;

  if(is_null($xhtml_renderer)){
    require_once(DOKU_INC.DOKU_TPL.'/yani_renderer_xhtml.php');
    $xhtml_renderer = new yani_Renderer_xhtml();
  }

  $default = $xhtml_renderer->_simpleTitle($id);
  resolve_pageid(getNS($id),$default,$exists);
  if ( $exists ) $name = $xhtml_renderer->_getLinkTitle($name, $default, $isImage, $id, 'navigation');
  else $name = getNS($id);

  return $name;
}

/* -------------------- Redefined functions -------------------- */
/**
 * Function based from search_index function by
 * @author  Andreas Gohr <andi@splitbrain.org>
 * See originals comments.
 */
function yani_html_wikilink($id,$name=NULL,$search=''){
  static $xhtml_renderer = NULL;
  if(is_null($xhtml_renderer)){
    /*to use our own renderer class,
     *only to change internallink function. */
    require_once(DOKU_INC.DOKU_TPL.'/yani_renderer_xhtml.php');
    $xhtml_renderer = new yani_Renderer_xhtml();
  }

  return $xhtml_renderer->internallink($id,$name,$search,true,'navigation');
}

/**
 * Function based from html_list_index function by
 * @author Andreas Gohr <andi@splitbrain.org>
 * See originals comments.
 */
function yani_html_list_index($item){
  // Now globals need them here.
  global $conf;
  global $ID;
  $ret = '';
  $base = ':'.$item['id'];
  $base = substr($base,strrpos($base,':')+1);
  // Create CSS class for current id.
  if ( ereg('^:'.$item['id'], ':'.$ID) ) {
    $idxcurclass = 'curid';
    $idxclass = 'IdxOpen';
  }
  else {
    $idxcurclass = '';
    $idxclass = 'IdxClose';
  }
  // Add CSS class when current id is a start page.
  if ( ereg($conf['start'].'$', $item['id']) ) {
    if ( $idxcurclass != '') $idxcurclass .= ' ';
    $idxcurclass .= 'startid';
  }
  if ( $idxcurclass != '' ) {
    $htag_o = '<span class="'.$idxcurclass.'">';
    $htag_c = '</span>';
  }
  else {
    $htag_o = '';
    $htag_c = '';
  }
  if($item['type']=='d'){
    $start=$item['id'].':'.$conf['start'];
    $ret .= '<a class="yani" href="'.wl($ID, 'idx='.rawurlencode($item['id'])).'" ><span class="TextOnly" title="Index">Index</span> </a><span class="TextOnly">/ </span>';
    $ret .= '<a href="'.rawurlencode($start).'" title="Vers '.getStartHeading($start).'">'.$htag_o;
    //$ret .= '<a href="'.rawurlencode($item['id'].':'.$conf['start']).'" title="Aller à l\'accueil '.$item['id'].'.">'.$htag_o;
    $ret .= '<span class="TextOnly">Accueil </span>'.ucfirst($base);
    $ret .= $htag_c.'</a>';
  }
  else{
    $ret .= $htag_o.yani_html_wikilink(':'.$item['id']).$htag_c;
  }
  return $ret;
}

/**
 * Function based from html_buildlist function by
 * @author Andreas Gohr <andi@splitbrain.org>
 * See originals comments.
 */
function yani_html_buildlist($data,$class,$func,$lifunc='html_li_default'){
  global $conf;
  $level = 0;
  $opens = 0;
  $ret   = '';

  foreach ($data as $item){

    /* we don't want start pages within list */
    if ( ereg('^.*:'.$conf['start'].'$', $item['id'] ) ) continue;
    if( $item['level'] > $level ){
      //open new list
      for($i=0; $i<($item['level'] - $level); $i++){
        if ($i) $ret .= "<li class=\"clear\">\n";
        $ret .= "\n<ul class=\"$class\">\n";
      }
    }elseif( $item['level'] < $level ){
      //close last item
      $ret .= "</li>\n";
      for ($i=0; $i<($level - $item['level']); $i++){
        //close higher lists
        $ret .= "</ul>\n</li>\n";
      }
    }else{
      //close last item
      $ret .= "</li>\n";
    }

    //remember current level
    $level = $item['level'];

    //print item
    $ret .= call_user_func($lifunc,$item);
    $ret .= '<div class="li">';

    $ret .= call_user_func($func,$item);
    $ret .= '</div>';
  }

  //close remaining items and lists
  for ($i=0; $i < $level; $i++){
    $ret .= "</li></ul>\n";
  }

  return $ret;
}

/**
 * Function based from html_index function by
 * @author Andreas Gohr <andi@splitbrain.org>
 * See originals comments.
 */
function yani_html_index($ns){
  require_once(DOKU_INC.'inc/search.php');
  global $conf;
  global $ID;
  $dir = $conf['datadir'];
  $ns  = cleanID($ns);
  #fixme use appropriate function
  if(empty($ns)){
    $ns = dirname(str_replace(':','/',$ID));
    if($ns == '.') $ns ='';
  }
  $ns  = utf8_encodeFN(str_replace(':','/',$ns));

  /* Remove official intro and just add title
   * according to the template needs. */
  echo '      <div class="TitleBlockBase">Index</div>';
  echo '        <div id="index__tree">';

  $data = array();
  // Use our own functions
  search($data,$conf['datadir'],'search_index',array('ns' => $ns));
  echo yani_html_buildlist($data,'idx','yani_html_list_index','html_li_index');

  echo '        </div> <!-- Fin de #index__tree -->';
}

?>
