<?php
/**
 * Renderer for XHTML output
 *
 * Class based on xhtml.php by
 * @author Harry Fuecks <hfuecks@gmail.com>
 * @author Andreas Gohr <andi@splitbrain.org>
 */
if(!defined('DOKU_INC')) die('meh.');

if ( !defined('DOKU_LF') ) {
    // Some whitespace to help View > Source
    define ('DOKU_LF',"\n");
}

if ( !defined('DOKU_TAB') ) {
    // Some whitespace to help View > Source
    define ('DOKU_TAB',"\t");
}

/* The original class Renderer_xhtml */
require_once(DOKU_INC.'inc/parser/xhtml.php');

/**
 * The Renderer
 * Our new class is an extend form the official one.
 * We just define internallink function for our purposes.
 */
class yani_Renderer_xhtml extends Doku_Renderer_xhtml {

    /**
     * Function based on function by
     * @author Andreas Gohr <andi@splitbrain.org>
     * See originals comments.
     */
    function internallink($id, $name = NULL, $search=NULL,$returnonly=false,$linktype='content') {
        global $conf;
        global $ID;
        // default name is based on $id as given
        $default = $this->_simpleTitle($id);

        // now first resolve and clean up the $id
        resolve_pageid(getNS($ID),$id,$exists);
        $name = $this->_getLinkTitle($name, $default, $isImage, $id, $linktype);
        if ( !$isImage ) {
            if ( $exists ) {
                $class='wikilink1';
            } else {
                $class='wikilink2';
                $link['rel']='nofollow';
            }
        } else {
            $class='media';
        }

        //keep hash anchor
        list($id,$hash) = explode('#',$id,2);
        if(!empty($hash)) $hash = $this->_headerToLink($hash);

        //prepare for formating
        $link['target'] = $conf['target']['wiki'];
        $link['style']  = '';
        $link['pre']    = '';
        $link['suf']    = '';
        /* highlight link to current page
         * Did elsewhere, into the sidebar template.
        if ($id == $ID) {
            $link['pre']    = '<span class="curid">';
            $link['suf']    = '</span>';
        }
         */
        $link['more']   = '';
        $link['class']  = $class;
        $link['url']    = wl($id);
        $link['name']   = $name;
        // Cut off when the name is too long.
        $lmn = 20; $smn = '...';
        // Don't cut the home page...
        if ( ( strlen($name) > $lmn ) and ( $conf['start'] != $id ) ) {
            $pos = strpos($name, ' ', $lmn-strlen($smn));
            if ( $pos > 0 ) $link['name'] = substr($name, 0, $pos).$smn;
        }
        // Now, html title is the name, not the id anymore.
        $link['title']  = $name;
        //add search string
        if($search){
            ($conf['userewrite']) ? $link['url'].='?' : $link['url'].='&amp;';
            if(is_array($search)){
                $search = array_map('rawurlencode',$search);
                $link['url'] .= 's[]='.join('&amp;s[]=',$search);
            }else{
                $link['url'] .= 's='.rawurlencode($search);
            }
        }

        //keep hash
        if($hash) $link['url'].='#'.$hash;

        //output formatted
        if($returnonly){
            return $this->_formatLink($link);
        }else{
            $this->doc .= $this->_formatLink($link);
        }
    }
}

//Setup VIM: ex: et ts=4 enc=utf-8 :
